//---------------------------------------------------------------------------
#ifndef AddrsDlgH
#define AddrsDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
const int modeNone = 0;
const int modeEdit = 1;
const int modeEditGrps = 2;
const int modeAddress = 3;
const int modeNoAddress = 4;

class TAddressDlg : public TForm
{
__published:	// IDE-managed Components
  TLabel *Label1;
  TButton *OkBtn;
  TButton *CancelBtn;
  TPageControl *PageControl1;
  TTabSheet *TabSheet1;
  TPanel *Panel3;
  TMemo *AddrsEditor;
  TListBox *AddrsList;
  TGroupBox *GroupBox1;
  TRadioButton *ToBtn;
  TRadioButton *CcBtn;
  TRadioButton *BccBtn;
  TSpeedButton *EditAddrBtn;
  TTabSheet *TabSheet2;
  TPanel *Panel1;
  TMemo *GrpsEditor;
  TListBox *GrpsList;
  TGroupBox *GroupBox2;
  TRadioButton *GroupsBtn;
  TRadioButton *FollowBtn;
  TSpeedButton *EditGrpsBtn;
	void __fastcall AddrsListDblClick(TObject *Sender);
	void __fastcall EditAddrBtnClick(TObject *Sender);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall CancelBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  int mode;
  int orglistwidth;
	__fastcall TAddressDlg(TComponent* Owner);
  bool __fastcall GetRecipients(TStrings *Addresses);
  void __fastcall SetMode(int Mode);
};

bool __fastcall GetMailRecipients(TStrings *Addresses, TStrings *Newsgroups,
   int Mode);
//---------------------------------------------------------------------------
extern TAddressDlg *AddressDlg;
//---------------------------------------------------------------------------
#endif
