//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Cyberpunk.h"
#include "Mixmaster.h"
#include "Pgpmail.h"
#include "global.h"

AnsiString cretbuf;
//---------------------------------------------------------------------------
int __fastcall CpkKeyCount(TStrings *KeyDoc)
{
   int keys=0;
   for (int i=0; i<KeyDoc->Count; i++)
      if (KeyDoc->Strings[i].Trim()=="-----BEGIN PGP PUBLIC KEY BLOCK-----")
         keys++;
   return keys;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkGetNewRemailerKeys(TStrings *KeyDoc)
{
   if (CpkKeyCount(KeyDoc)>1)
      KeyDoc->SetText(PgpArmorKeysToArmorBlock(KeyDoc->Text.c_str()));
   AnsiString keys = PgpGetNewRemailerKeys(KeyDoc->Text.c_str());
   return keys;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkAddNewRemailerKeys(TStrings *KeyDoc)
{
   if (CpkKeyCount(KeyDoc)>1)
      KeyDoc->SetText(PgpArmorKeysToArmorBlock(KeyDoc->Text.c_str()));
   AnsiString keys = PgpAddNewRemailerKeys(KeyDoc->Text.c_str());
   return keys;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkType1Doubles()
{
  int i,c;
  TStringList *dbls = new TStringList();
  TStringList *type1 = new TStringList();
  AnsiString s,id,line,ctyp1txt=MixDir()+CTyp1Txt;
  if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
  for (i=0; i<type1->Count; i++)
  {
    if (type1->Strings[i].Pos("#")==1) continue;
    id = GetParam(2,type1->Strings[i]," ");
    // initialize to zero
    if (dbls->Values[id].IsEmpty()) dbls->Values[id]="0";
    // increment value
    c = dbls->Values[id].ToIntDef(0)+1;
    // assign incidence count
    dbls->Values[id] = AnsiString(c);
  }
  i=0; while(i<dbls->Count)
  {
    s = dbls->Strings[i];
    if (s.Pos("=1")==0)
    {
       dbls->Strings[i] = s.SubString(1,s.Pos("=")-1);
       i++;
    }
    else dbls->Delete(i);
  }
  cretbuf = dbls->Text;
  delete type1;
  delete dbls;
  return cretbuf;
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *list)
{
   bool ok = false;
   for (int i=0; i<list->Count; i++)
   {
      if (list->Strings[i]==remailer || list->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkGenType1()
{
   AnsiString line,cline,rline,shrt,
      ctyp1txt=MixDir()+CTyp1Txt,cringtxt=MixDir()+CRingTxt,
      clisttxt=MixDir()+CListTxt;
   TStringList *clist = new TStringList();
   if (FileExists(clisttxt)) clist->LoadFromFile(clisttxt);
   TStringList *cring = new TStringList();
   if (FileExists(cringtxt)) cring->LoadFromFile(cringtxt);
   TStringList *type1 = new TStringList();
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
   TStringList *rems = new TStringList();
   rems->Text = CpkRemLines();
   // remove all but disabled keys from type1.list
   int i=0; while (i<type1->Count)
   {
      if (type1->Strings[i].SubString(1,1)!="#") type1->Delete(i);
      else i++;
   }
   for (i=0; i<clist->Count; i++)
   {
      cline = clist->Strings[i];
      if (!CpkListLineOk(cline)) continue;
      for (int r=0; r<rems->Count; r++)
      {
         rline = rems->Strings[r];
         if (rline.Pos(GetParam(0,cline," ")+" ")==1 && !InType1(rline,type1))
            type1->Add(rline);
      }
   }
   cretbuf = type1->Text;
   delete rems;
   delete type1;
   delete cring;
   delete clist;
   return cretbuf;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkRemLines()
{
   int p;
   AnsiString tmp,keyid,line,shrt,adrs,caps,nokeyfound="----------",
      clisttxt=MixDir()+CListTxt,cringtxt=MixDir()+CRingTxt;
   TStringList *ids = new TStringList();
   ids->SetText(PgpGetUserIdsKeyIds(cringtxt.c_str()));
   TStringList *rems = new TStringList();
   if (FileExists(clisttxt)) rems->LoadFromFile(clisttxt);
   TStringList *lines = new TStringList();
   for (int r=0; r<rems->Count; r++)
   {
      line = rems->Strings[r].Trim();
      if (line.Pos("$remailer{")==1)
      {
         keyid = nokeyfound;
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         adrs = GetParam(0,caps," ");
         caps = caps.SubString(adrs.Length()+2,512);
         while ((p=adrs.Pos("<"))>0 || (p=adrs.Pos(">"))>0) adrs.Delete(p,1);
         for (int i=0; i<ids->Count; i++)
            if (ids->Strings[i].Pos(adrs)>0)
            {
               keyid = "0x"+GetParam(0,ids->Strings[i],"=");
               break;
            }
         lines->Add(shrt+" "+adrs+" "+keyid+" "+caps);
      }
   }
   cretbuf = lines->Text;
   delete lines;
   delete rems;
   delete ids;
   return cretbuf;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr)
{
   fromStr = fromStr.Trim();
   int p = fromStr.Pos(" ");
   AnsiString prm=fromStr.Trim().SubString(1,p-1);
   if (pos>0) return GetParamSpc(pos-1,fromStr.SubString(p,256));
   return prm;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkListKeyNotFound()
{
   int t,c;
   AnsiString line,shrt,cline,tline,
      clisttxt=MixDir()+CListTxt,ctyp1txt=MixDir()+CTyp1Txt;
   TStringList *clist = new TStringList();
   if (FileExists(clisttxt)) clist->LoadFromFile(clisttxt);
   TStringList *type1 = new TStringList();
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
   // Get all short names in clist.txt
   c=0; while (c<clist->Count)
   {
      line = clist->Strings[c];
      if (CpkListLineOk(line))
      {
         clist->Strings[c] = GetParam(0,line," ")+GetParamSpc(1,line);
         c++;
      }
      else clist->Delete(c);
   }
   TStringList *nokeys = new TStringList();
   // if a short name is in clist and not type1, add it to nokeys
   for (c=0; c<clist->Count; c++)
   {
      cline = clist->Strings[c];
      for (t=0; t<type1->Count; t++)
      {
         tline = type1->Strings[t];
         if (tline.Pos(GetParam(0,cline," "))<0 && tline.Pos("#"+cline)<0)
            nokeys->Add(cline);
      }
   }
   cretbuf = nokeys->Text;
   delete nokeys;
   delete type1;
   delete clist;
   return cretbuf;
}
//---------------------------------------------------------------------------
bool __fastcall CpkRingLineOk(AnsiString &line)
{
   return GetParam(1,line," ").Pos("0x")==1;
}
//---------------------------------------------------------------------------
bool __fastcall CpkListLineOk(AnsiString &line)
{
 //"redneck  config@redneck.gacracker.org     ###***##*###      :27 100.00%"
   int l=line.Length();
   AnsiString addr = GetParamSpc(1,line);
   bool ok = addr.Pos("@");
   if (ok) ok = l && line[l-10]==':';
   if (ok) ok = l && line[l-3]=='.';
   if (ok) ok = l && line[l]=='%';
   return ok;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall CpkGenType1()
{
   char* nokeyfound="----------";
   AnsiString tmps,shrt,addr,caps,line,keyid,type1str,
      ctyp1txt=MixDir()+CTyp1Txt,clisttxt=MixDir()+CListTxt,
      cringtxt=MixDir()+CRingTxt;

   int d,t,r,i,p;
   TStringList *activ = new TStringList();
   TStringList *rlist = new TStringList();
   TStringList *type1 = new TStringList();
   TStringList *disab = new TStringList();
   // get disabled keys from type1.list
   if (FileExists(ctyp1txt)) disab->LoadFromFile(ctyp1txt);
   d=0; while (d<disab->Count)
   {
      if (disab->Strings[d].SubString(1,1)!="#") disab->Delete(d);
      else d++;
   }
   // start with the remailer stats report
   if (FileExists(clisttxt)) rlist->LoadFromFile(clisttxt);
   for (r=0; r<rlist->Count; r++)
   {
      line = rlist->Strings[r].Trim();
      if (line.Pos("$remailer{")==1) // get remailer def lines
      {
         shrt = GetParam(1,line,"\"");
         caps = GetParam(3,line,"\"");
         if ((p=caps.Pos("<"))==1) caps.Delete(p,1);
         if ((p=caps.Pos(">"))>0 ) caps.Delete(p,1);
         //addr = GetParam(0,caps," ");
         type1->Add(shrt+" "+caps);
      }
      else
      if (CpkListLineOk(line)) // get list of active remailers
      {
         activ->Add(GetParam(0,line," "));
      }
   }
   // dump all remailer defs not active in stats portion of list
   t=0; while (t<type1->Count)
   {
      if (activ->IndexOf(GetParam(0,type1->Strings[t]," "))<0) type1->Delete(t);
      else t++;
   }
   // get corresponding key id
   TStringList *keyids = new TStringList();
   keyids->SetText(PgpGetUserIdsKeyIds(cringtxt.c_str()));
   for (t=0; t<type1->Count; t++)
   {
      keyid = nokeyfound;
      type1str = type1->Strings[t];
      shrt = GetParam(0,type1str," ");
      addr = GetParam(1,type1str," ");
      for (i=0; i<keyids->Count; i++)
      {
         line = keyids->Strings[i];
         if (line.Pos(addr)>0)
         {
            keyid = "0x"+line.SubString(1,8);
            break;
         }
      }
      type1str = "";
      p=2; while (!(caps=GetParam(p,type1->Strings[t]," ")).IsEmpty())
      {
         type1str += " "+caps;
         p++;
      }
      type1->Strings[t] = shrt+" "+addr+" "+keyid+type1str;
   }
   delete keyids;
   // delete disableds in type1.list and add the actual disabled line
   for (d=0; d<disab->Count; d++)
   {
      line = disab->Strings[d].SubString(2,512);
      while ((t=type1->IndexOf(line))>=0)
         type1->Delete(t);
      type1->Add("#"+line);
   }
   // look for keys that did not have a key available
   TStringList *nokeys = new TStringList();
   for (t=0; t<type1->Count; t++)
   {
      line = type1->Strings[t];
      if (line.Pos(nokeyfound)>0 && line[1]!='#')
         nokeys->Add(GetParam(0,line," ")+" "+GetParam(1,line," "));
   }
   // inform the user of problem remailers
   if (nokeys->Count)
   {
      MsgBox(
         s("=================SOME PGP KEYS NOT FOUND=================\n")+
         s("\nYou have ")+s(nokeys->Count)+s(" remailers in your type1.list file that you do not have PGP keys\n")+
         s("for. Please have a look. You've got 3 options.\n\n")+
         s("1) If you updated your pubring.asc from the same source as your current\n")+
         s("rlist.txt, you will more than likely get that key. 2) You can leave them 'as is'.\n")+
         s("They won't be used, until a key is found, but I'll nag you with this dialog,\n")+
         s("after updates. 3) You can disable them with a pound sign '#' in front of those\n")+
         s("remailers in the type1.list file. In that case, I won't nag you, but I won't add\n")+
         s("those new keys when I find them, either.\n \n \n")+
         nokeys->Text+s("\n \n \n"),
         "TYPE1.LIST",
         MB_OK
      );
   }
   delete nokeys;

   AnsiString type1lines = type1->Text;
   delete disab;
   delete type1;
   delete activ;
   return type1lines.c_str();
}
*/